;##################################################################
; CTreeview
;##################################################################

#include "CTreeview.Inc"

/*
#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists
*/

IDD_DLG1	equ		1000

TVM_INSERTCOLUMN equ HDM_INSERTITEM
TVM_REMOVECOLUMN equ HDM_DELETEITEM
TVM_GETCOLUMN equ HDM_GETITEM
TVM_SETSUBITEM equ WM_USER + 102
TVM_SETHDRFONT equ WM_USER + 103
TVM_SETEXTENDEDLISTVIEWSTYLE equ LVM_SETEXTENDEDLISTVIEWSTYLE
TVS_EX_GRIDLINES equ LVS_EX_GRIDLINES

TVSUBITEM STRUCT
	hParent DD
	nColumn	DD
	pszText	DD
ENDS

TVCOLUMN STRUCT
	lxy			DD
	pszLabel	DD
	cchTextMax	DD
	lParam		DD
ENDS

DATA SECTION
	hInstance	DD		?
	hTreeview	DD		?

	col1text	DB		"Column 1",0
	col2text	DB		"Column 2",0
	col3text	DB		"Column 3",0
	col4text	DB		"Column 4",0
	col5text	DB		"Column 5",0

	hArial_12	DD		?
	Arial_12	LOGFONT	<-16,0,0,0,400,0,0,0,0,3,2,1,34,"Arial">

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke CreateFontIndirect,offset Arial_12
	mov [hArial_12],eax
	invoke InitCommonControls
	; Must initialize the superclassing
	invoke InitClass
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke DeleteObject,[hArial_12]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL rect		:RECT
	LOCAL tvc		:TVCOLUMN
	LOCAL tvins		:TV_INSERTSTRUCT
	LOCAL tvsi		:TVSUBITEM

	; Just insert this as the first line in the WndProc
	; the rest is automatic
	invoke DrawTreeview,[hwnd],[uMsg],[wParam],[lParam]
	jz >
		ret
	:

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >>.WMCOMMAND
		invoke GetDlgItem,[hwnd],1001
		mov [hTreeview],eax
		mov D[tvc.lxy],100
		mov [tvc.pszLabel],offset col1text
		mov D[tvc.lParam],0
		invoke SendMessage,[hTreeview],TVM_INSERTCOLUMN,5,offset tvc
		mov [tvc.pszLabel],offset col2text
		invoke SendMessage,[hTreeview],TVM_INSERTCOLUMN,5,offset tvc
		mov [tvc.pszLabel],offset col3text
		invoke SendMessage,[hTreeview],TVM_INSERTCOLUMN,5,offset tvc
		mov [tvc.pszLabel],offset col4text
		invoke SendMessage,[hTreeview],TVM_INSERTCOLUMN,5,offset tvc

		invoke SendMessage,[hTreeview],TVM_SETEXTENDEDLISTVIEWSTYLE,TVS_EX_GRIDLINES,TVS_EX_GRIDLINES

		mov D[tvins.hParent],0
		mov D[tvins.itemex.lParam],0
		mov D[tvins.hInsertAfter],0
		mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM
		push "Root"
		pop [tvins.itemex.pszText]
		invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins
		push eax

		mov [tvins.hParent],eax
		push "One"
		pop [tvins.itemex.lParam]
		mov D[tvins.hInsertAfter],0
		mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM
		push "Item 1"
		pop [tvins.itemex.pszText]
		invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins
		
		mov [tvsi.hParent],eax
		mov D[tvsi.nColumn],0
		push "One"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi

		pop eax
		mov [tvins.hParent],eax
		push "Two"
		pop [tvins.itemex.lParam]
		mov D[tvins.hInsertAfter],0
		mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM
		push "Item 2"
		pop [tvins.itemex.pszText]
		invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

		mov [tvsi.hParent],eax
		mov D[tvsi.nColumn],0
		push "Two"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi
		mov D[tvsi.nColumn],1
		push "Zippedy"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi
		mov D[tvsi.nColumn],2
		push "DoDah"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi

		mov D[tvins.hParent],0
		mov D[tvins.itemex.lParam],0
		mov D[tvins.hInsertAfter],0
		mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM
		push "Root 2"
		pop [tvins.itemex.pszText]
		invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins

		mov [tvins.hParent],eax
		push "Three"
		pop [tvins.itemex.lParam]
		mov D[tvins.hInsertAfter],0
		mov D[tvins.itemex.imask],TVIF_TEXT + TVIF_PARAM
		push "Item 3"
		pop [tvins.itemex.pszText]
		invoke SendMessage,[hTreeview],TVM_INSERTITEM,0,addr tvins
		
		mov [tvsi.hParent],eax
		mov D[tvsi.nColumn],0
		push "Three"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi
		mov D[tvsi.nColumn],1
		push "Four"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi
		mov D[tvsi.nColumn],2
		push "Five"
		pop [tvsi.pszText]
		invoke SendMessage,[hTreeview],TVM_SETSUBITEM,0,addr tvsi

		invoke SendMessage,[hTreeview],WM_SETFONT,[hArial_12],TRUE
		invoke SendMessage,[hTreeview],TVM_SETHDRFONT,[hArial_12],TRUE

		mov eax, TRUE
		ret

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMCLOSE

		jmp >>.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

DrawTreeview FRAME hwnd,uMsg,wParam,lParam
	uses ebx,edi,esi
	LOCAL tvi			:TVITEM
	LOCAL rect			:RECT
	LOCAL hHeader		:D
	LOCAL hControl		:D
	LOCAL hDC			:D
	LOCAL hPen			:D
	LOCAL hFillBrush	:D
	LOCAL Indent		:D
	LOCAL buffer[256]	:B
	LOCAL pOldProc		:D

	cmp D[uMsg],WM_NOTIFY
	je >
		xor eax,eax
		ret
	:
	mov edi,[lParam]

	cmp D[edi+NMHDR.code],NM_CUSTOMDRAW 
	je >
		xor eax,eax
		ret
	:

	mov eax,[edi+NMHDR.hwndFrom]
	mov [hControl],eax

	; We must distinguish from a normal treeview owner draw
	; and our superclassed one. Rather than track all the handles
	; our treeview simply sets a variable in the class memory to check
	invoke GetClassLong,eax,0
	cmp eax,987654321
	je >
		xor eax,eax
		ret
	:

	invoke GetClassLong,[hControl],4
	mov [pOldProc],eax

	invoke GetWindowLong,[hControl],08h
	mov [hHeader],eax

	invoke CallWindowProc,[pOldProc],[hControl],TVM_GETINDENT,0,0
	mov [Indent],eax

	mov eax,[edi+NMTVCUSTOMDRAW.nmcd.dwDrawStage]
	cmp eax,CDDS_PREPAINT
	jne >
		; Request an item draw notification
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_NOTIFYITEMDRAW+CDRF_NOTIFYPOSTPAINT
		xor eax,eax
		inc eax
		ret

	:
	cmp eax,CDDS_ITEMPREPAINT
	jne >>.PAINTGRID
		
		mov eax,[edi+NMTVCUSTOMDRAW.iLevel]
		dec eax
		jnz >>.DODEFAULT
			; This only works with level 1 items
			mov eax,[edi+NMCUSTOMDRAW.dwItemSpec]
			mov [tvi.hItem],eax
			lea eax,buffer
			mov D[tvi.pszText],eax
			mov D[tvi.cchTextMax],256
			mov D[tvi.imask],TVIF_TEXT+TVIF_PARAM
			; Have to call this directly so we don't get the other lParam
			invoke CallWindowProc,[pOldProc],[hControl],TVM_GETITEM,0,offset tvi

			invoke GetBkColor,[edi+NMCUSTOMDRAW.hdc]
			invoke CreateSolidBrush,eax
			mov [hFillBrush],eax
			invoke GetClientRect,[hControl],offset rect
			mov eax,[edi+NMCUSTOMDRAW.rc.top]
			mov [rect.top],eax
			mov eax,[edi+NMCUSTOMDRAW.rc.bottom]
			mov [rect.bottom],eax
			mov D[rect.left],0
			invoke FillRect,[edi+NMCUSTOMDRAW.hdc],offset rect,[hFillBrush]
			invoke DeleteObject,[hFillBrush]

			;Draw the item
			invoke SendMessage,[hHeader],HDM_GETITEMRECT,0,offset rect
			mov eax,[edi+NMCUSTOMDRAW.rc.top]
			mov [rect.top],eax
			mov eax,[edi+NMCUSTOMDRAW.rc.bottom]
			mov [rect.bottom],eax
			mov eax,[edi+NMCUSTOMDRAW.rc.left]
			mov eax,[Indent]
			shl eax,1
			mov D[rect.left],eax
			invoke DrawText,[edi+NMCUSTOMDRAW.hdc],offset buffer,-1,offset rect,DT_BOTTOM + DT_LEFT + DT_END_ELLIPSIS + DT_SINGLELINE + DT_VCENTER

			invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
			mov esi,eax
			xor ebx,ebx
			inc ebx
			:
			invoke SendMessage,[hHeader],HDM_GETITEMRECT,ebx,offset rect
			mov eax,[edi+NMCUSTOMDRAW.rc.top]
			mov [rect.top],eax
			mov eax,[edi+NMCUSTOMDRAW.rc.bottom]
			mov [rect.bottom],eax
			mov eax,[tvi.lParam]
			or eax,eax
			jz >.NOTEXT
			mov eax,[eax+ebx*4]
			jz >.NOTEXT
			add D[rect.left],2
			invoke DrawText,[edi+NMCUSTOMDRAW.hdc],eax,-1,offset rect,DT_BOTTOM + DT_LEFT + DT_END_ELLIPSIS + DT_SINGLELINE + DT_VCENTER
			.NOTEXT
			inc ebx
			cmp ebx,esi
			jb <<
			invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_SKIPDEFAULT
			jmp >>.EXIT

	.PAINTGRID
	cmp eax,CDDS_POSTPAINT
	jne >>.DODEFAULT
		invoke GetWindowLong,[hControl],18h
		test eax,LVS_EX_GRIDLINES
		jz >>.DODEFAULT
		invoke GetClientRect,[hControl],offset rect
		invoke CallWindowProc,[pOldProc],[hControl],TVM_GETITEMHEIGHT,0,0
		mov ebx,eax
		invoke CallWindowProc,[pOldProc],[hControl],TVM_GETVISIBLECOUNT,0,0
		mov edi,eax
		invoke GetDC,[hControl]
		mov [hDC],eax
		xor esi,esi
		invoke CreatePen,PS_SOLID,1,00C0C0C0h
		mov [hPen],eax
		invoke SelectObject,[hDC],[hPen]
		push eax
		push [rect.bottom]
		; Draw horizontal lines
		:
		add esi,ebx
		invoke MoveToEx,[hDC],0,esi,0
		invoke LineTo,[hDC],[rect.right],esi
		dec edi
		jnz <
		
		pop edi
		
		; Draw vertical lines
		invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
		mov esi,eax
		xor ebx,ebx
		:
		invoke SendMessage,[hHeader],HDM_GETITEMRECT,ebx,offset rect
		dec D[rect.right]
		invoke MoveToEx,[hDC],[rect.right],0,0
		invoke LineTo,[hDC],[rect.right],edi
		inc ebx
		cmp ebx,esi
		jb <<

		pop eax
		invoke SelectObject,[hDC],eax
		invoke ReleaseDC,[hControl],[hDC]
		invoke DeleteObject,[hPen]

	.DODEFAULT
	invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_DODEFAULT
	.EXIT
	xor eax,eax
	inc eax
	ret

ENDF

; Superclass the treeview control
InitClass FRAME
	LOCAL cc_wcx			:WNDCLASSEX
	LOCAL buffer[64]		:B

	mov D[cc_wcx.cbSize],SIZEOF WNDCLASSEX
	invoke GetClassInfoEx,[hInstance],"SysTreeView32",offset cc_wcx
	invoke GetModuleHandle,0
	mov D[cc_wcx.hInstance],eax
	mov D[cc_wcx.lpszClassName],OFFSET UDC_Class
	mov D[cc_wcx.cbClsExtra],8
	mov D[cc_wcx.cbWndExtra],32 ; first 4 bytes reserved for Treeview
	mov eax,[cc_wcx.lpfnWndProc]
	invoke wsprintf,offset buffer,"%u",eax
	add esp,12
	lea eax,buffer
	mov D[cc_wcx.lpszMenuName],eax
	mov D[cc_wcx.lpfnWndProc],OFFSET CTreeViewproc

	invoke RegisterClassEx,ADDR cc_wcx
	invoke SetLastError,0
	ret

	UDC_Class:	db		"UDC_ControlClass",0
ENDF

CTreeViewproc FRAME hwnd,uMsg,wParam,lParam
	uses ebx,edi,esi
	LOCAL rect		:RECT
	LOCAL tvi		:TVITEM
	LOCAL wcx		:WNDCLASSEX
	LOCAL hdi		:HD_ITEM
	LOCAL tvins		:TV_INSERTSTRUCT
	LOCAL lf		:LOGFONT
	LOCAL pt		:POINT

	; Control memory
	; 00h = Reserved for Treeview
	; 04h = # columns
	; 08h = hHeader control
	; 0Ch = Heap handle for this control
	; 10h = PTR to RECT of treeview
	; 14h = Old header proc address
	; 18h = extended style

	cmp D[uMsg],TVM_INSERTITEM
	jne >
		mov edi,[lParam]
		mov eax,[edi+TV_INSERTSTRUCT.hParent]
		or eax,eax
		jz >>.EXIT
		mov eax,[edi+TV_INSERTSTRUCT.itemex.imask]
		or eax,TVIF_PARAM
		mov [edi+TV_INSERTSTRUCT.itemex.imask],eax
		invoke GetWindowLong,[hwnd],0Ch
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,64
		mov [edi+TV_INSERTSTRUCT.itemex.lParam],eax
		jmp >>.EXIT

	:
	cmp D[uMsg],TVM_DELETEITEM
	jne >
		; we must intercept the TVM_DELETEITEM
		; in order to free the memory associated
		; with the item
		mov ebx,[wParam]
		mov D[tvi.imask],TVIF_PARAM
		mov [tvi.hItem],ebx
		; Get the item information directly
		invoke GetClassLong,[hwnd],4
		invoke CallWindowProc,eax,[hwnd],TVM_GETITEM,0,offset tvi
		mov ebx,[tvi.lParam]
		or ebx,ebx
		jz >>.EXIT
		; Get the heap
		invoke GetWindowLong,[hwnd],0Ch
		mov esi,eax
		; Free each of the strings first
		xor esi,esi
		L1:
		mov ecx,esi
		shl ecx,2
		add ecx,[tvi.lParam]
		add ecx,4
		mov eax,[ecx]
		or eax,eax
		jz >.NOSTRING
		invoke HeapFree,esi,0,eax
		.NOSTRING
		inc esi
		cmp esi,16
		jb <L1
		; Free the pointers
		invoke HeapFree,esi,0,ebx
		jmp >>.EXIT

	:
	cmp D[uMsg],WM_DESTROY
	jne >
		invoke GetWindowLong,[hwnd],10h
		invoke GlobalFree,eax
		; Free all of the items by destroying the heap
		invoke GetWindowLong,[hwnd],0Ch
		invoke HeapDestroy,eax
		jmp >>.EXIT

	:
	cmp D[uMsg],WM_NOTIFY
	jne >
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],HDN_ITEMCHANGED
		jnz >>.EXIT
			.REDRAW
			; Redraw the control when header resized
			invoke InvalidateRect,[hwnd],NULL,TRUE
			invoke UpdateWindow,[hwnd]
			jmp >>.EXIT

	:
	cmp D[uMsg],TVM_INSERTCOLUMN
	jne >>
		mov edi,[lParam]
		; Get the header handle
		mov D[hdi.imask],HDI_TEXT+HDI_WIDTH+HDI_LPARAM+HDI_FORMAT
		mov eax,[edi+TVCOLUMN.lxy]
		mov [hdi.lxy],eax
		mov eax,[edi+TVCOLUMN.pszLabel]
		mov [hdi.pszText],eax
		mov eax,[edi+TVCOLUMN.lParam]
		mov [hdi.lParam],eax
		mov D[hdi.fmt],HDF_STRING
		invoke GetWindowLong,[hwnd],08h
		mov ebx,eax
		invoke SendMessage,ebx,HDM_INSERTITEM,[wParam],offset hdi
		ret

	:
	cmp D[uMsg],TVM_GETITEM
	jne >
		; A cheat so we still have an lParam
		mov edi,[lParam]
		mov eax,[edi+TVITEM.imask]
		or eax,TVIF_PARAM
		mov [edi+TVITEM.imask],eax
		invoke GetClassLong,[hwnd],4
		invoke CallWindowProc,eax,[hwnd],TVM_GETITEM,0,edi
		mov eax,[edi+TVITEM.lParam]
		or eax,eax
		jz >.NOPARAM
		mov eax,[eax]
		.NOPARAM
		mov [edi+TVITEM.lParam],eax
		ret

	:
	cmp D[uMsg],TVM_SETITEM
	jne >
		; Do not allow the lParam to be modified
		mov edi,[lParam]
		mov D[tvi.imask],TVIF_PARAM
		mov eax,[edi+TVITEM.hItem]
		mov [tvi.hItem],eax
		invoke GetClassLong,[hwnd],4
		invoke CallWindowProc,eax,[hwnd],TVM_GETITEM,0,offset tvi
		mov eax,[tvi.lParam]
		or eax,eax
		jz >.NOPARAM2
			mov edx,[edi+TVITEM.lParam]
			mov [eax],edx
			mov eax,[edi+TVITEM.imask]
			and eax,0FFFFFFFBh
			mov [edi+TVITEM.imask],eax
		.NOPARAM2
		jmp >>.EXIT

	:
	cmp D[uMsg],TVM_SETSUBITEM
	jne >>
		mov edi,[lParam]
		mov D[tvi.imask],TVIF_PARAM
		mov eax,[edi+TVSUBITEM.hParent]
		mov [tvi.hItem],eax
		invoke GetClassLong,[hwnd],4
		invoke CallWindowProc,eax,[hwnd],TVM_GETITEM,0,offset tvi

		mov ecx,[edi+TVSUBITEM.nColumn]
		shl ecx,2
		add ecx,[tvi.lParam]
		add ecx,4
		mov eax,[ecx]
		or eax,eax
		jz >.ISFREE
		invoke HeapFree,ebx,0,eax
		.ISFREE
		invoke GetWindowLong,[hwnd],0Ch
		mov ebx,eax
		invoke lstrlen,[edi+TVSUBITEM.pszText]
		invoke HeapAlloc,ebx,HEAP_ZERO_MEMORY,eax
		mov ecx,[edi+TVSUBITEM.nColumn]
		shl ecx,2
		add ecx,[tvi.lParam]
		add ecx,4 ; Starts at item 1 so skip the first one
		mov [ecx],eax
		invoke lstrcpy,eax,[edi+TVSUBITEM.pszText]
		jmp .REDRAW
		ret

	:
	cmp D[uMsg],TVM_SETHDRFONT
	jne >
		invoke GetWindowLong,[hwnd],08h
		invoke PostMessage,eax,WM_SETFONT,[wParam],[lParam]
		ret

	:
	cmp D[uMsg],TVM_SETEXTENDEDLISTVIEWSTYLE
	jne >
		invoke GetWindowLong,[hwnd],18h
		mov edx,[wParam]
		neg edx
		and eax,edx
		or eax,[lParam]
		invoke SetWindowLong,[hwnd],18h,eax
		jmp >>.EXIT

	:
	cmp D[uMsg],WM_CREATE
	jne >>
		; Get the permanent size of the Treeview
		; Need this for sizing later
		invoke GlobalAlloc,GMEM_FIXED,16
		mov ebx,eax
		invoke SetWindowLong,[hwnd],10h,ebx
		invoke GetWindowRect,[hwnd],ebx
		mov eax,[ebx+RECT.top]
		sub [ebx+RECT.bottom],eax
		mov eax,[ebx+RECT.left]
		sub [ebx+RECT.right],eax

		invoke GetClientRect,[hwnd],offset rect
		invoke GetModuleHandle,NULL
		invoke CreateWindowEx,WS_EX_STATICEDGE,"SysHeader32",NULL,WS_CHILD + WS_VISIBLE, \
					0,0,[rect.right],20,[hwnd],1000,eax,NULL
		mov ebx,eax
		invoke SetWindowLong,ebx,GWL_WNDPROC,offset HDRSubClass
		invoke SetWindowLong,[hwnd],14h,eax
		invoke SetWindowLong,ebx,GWL_USERDATA,[hwnd]

		invoke GetStockObject,DEFAULT_GUI_FONT
		invoke PostMessage,ebx,WM_SETFONT,eax,TRUE

		invoke SetWindowLong,[hwnd],08h,ebx
		invoke HeapCreate,0,0100000h,0100000h
		invoke SetWindowLong,[hwnd],0Ch,eax
		invoke SetClassLong,[hwnd],0,987654321
		invoke GetDC,[hwnd]

	:
	cmp D[uMsg],WM_NCCREATE
	jne >
		; we stored the old proc in the menu name
		; that way there is no need to create a variable for it
		; This must be processed as the first message
		invoke GetClassLong,[hwnd],GCL_MENUNAME
		invoke ascii2dw,eax
		invoke SetClassLong,[hwnd],4,eax

	:
	.EXIT

	invoke GetClassLong,[hwnd],4
	invoke CallWindowProc,eax,[hwnd],[uMsg],[wParam],[lParam]
	RET
ENDF

HDRSubClass FRAME hwnd,uMsg,wParam,lParam
	uses ebx,edi,esi
	LOCAL lf		:LOGFONT
	LOCAL pt		:POINT

	invoke GetWindowLong,[hwnd],GWL_USERDATA
	mov ebx,eax
	cmp D[uMsg],WM_SETFONT
	jne >>
		invoke GetObject,[wParam],SIZEOF LOGFONT,offset lf
		mov eax,[lf.lfHeight]
		neg eax
		mov ecx,96
		mul ecx
		mov ecx,72
		div ecx
		add eax,2
		mov edi,eax ; height of header control

		; Get the fixed window RECT
		invoke GetWindowLong,ebx,10h
		mov esi,[eax+RECT.right]
		push eax

		mov D[pt.x],0
		mov D[pt.y],0
		invoke GetParent,ebx
		push eax
		invoke MapWindowPoints,[hwnd],eax,offset pt,1
		; pt holds the x/y coordinates of the window
		pop eax
		invoke SetParent,[hwnd],eax
		mov eax,edi
		add eax,3 ; border ????
		invoke SetWindowPos,[hwnd],0,[pt.x],[pt.y],esi,eax,SWP_NOZORDER

		; Squish the treeview
		pop edx ; pop the pointer to the window RECT
		mov eax,[edx+RECT.bottom]
		sub eax,edi
		add [pt.y],edi
		invoke SetWindowPos,ebx,0,[pt.x],[pt.y],esi,eax,SWP_NOZORDER

	:
	invoke GetWindowLong,ebx,14h
	invoke CallWindowProc,eax,[hwnd],[uMsg],[wParam],[lParam]
	
	RET
ENDF

; This is only used once to convert the old proc address to a DWORD
ascii2dw FRAME lpBuffer
	uses esi
	; The Svin

	mov esi, [lpBuffer]
	cmp B[esi],"-"
	jne  >S1
		inc esi
		xor eax,eax
		xor edx,edx
		jmp >N1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		N1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		neg eax
		ret

	S1:
		xor eax,eax
		xor edx,edx
		jmp >P1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		P1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		ret
ENDF
